#!/bin/sh

# susegen.sh, v 0.6 28/10/2002 by Kailed kailed@telvia.it

# Lo script crea un repository rpm per apt4rpm.
# Il repository creato
# pu essere copiato su CD e passato a apt-cdrom
# Susegen.sh non richiede (dipende da diversi fattori..) i privilegi di
# root, dovete per avere i permessi necessari per leggere e/o scrivere
# le directory: $APTDIR, $MIRRORDIR e $CONTRIBDIR


# Configurazione
GREEN='\033[;032m'        # verde
OUT='\033[0m'	          # reset
RED='\033[;031m'          # rosso
RED_LIGHT='\033[1;031m'   # rosso chiaro

# nome/versione/autore del programma..
NAME="SuSEgen.sh v. 0.6 by Kailed\n"
MSG_OUT="${GREEN}HAVE A LOT OF FUN :)${OUT}"

# Nome distribuzione (quello che vi pare..)
#DISTR=SuSE
DISTR=
# versione
#VERSION=8.1-i586
VERSION=
# versione di APT
# se avete apt-0.3.19
# APT_VERSION=old
#
# se avete apt-0.50.x
APT_VERSION=new

# La directory che verr utilizzata per creare il repository.
# La dovete creare voi PRIMA di eseguire susegen.sh
#APTDIR=/linux2
APTDIR=
# La directory che contiene gli RPM ufficiali (updates, o comunque rpm
# strettamente per suse..)
# /var/cache/apt/archives # se volete creare un repository da APT..
#MIRRORDIR=/var/cache/apt/archives
MIRRORDIR=

# La directory dei contrib (rpm creati da sorgenti, rpm non Suse, ma compatibili,
# non disponibili sui repository ufficiali.
#CONTRIBDIR=/tmp/rpmmirror
CONTRIB=
# START !!
clear
echo -e $NAME

# FUNZIONI

hash() {
    if [ $APT_VERSION = "old" ]; then
      genbasedir --topdir=${APTDIR} --hashonly \
        ${DISTR}/${VERSION} $* >/dev/null 2>/dev/null
    elif [ $APT_VERSION = "new" ]; then
      genbasedir --hashonly ${APTDIR}/${DISTR}/${VERSION} $* >/dev/null 2>/dev/null
    fi
}

configured() {
    MODL=$1
    test -r "${APTDIR}/${DISTR}/${VERSION}/base/release.${MODL}"
    return $?
}

gen() {
    MODL=$1
        if ! `which genbasedir >/dev/null 2>&1`; then
        echo -e "ATTENZIONE! Impossibile eseguire \"genbasedir\". Dovete installare APT!"
        return 1
    fi
    echo -en "\nGenerating ${DISTR}/${VERSION}/${MODL} : "
    if configured ${MODL}; then
        echo "attentere..."  
        if [ $APT_VERSION = "old" ]; then
           genbasedir --topdir=${APTDIR} --flat --bloat --bz2only --progress \
               ${DISTR}/${VERSION} ${MODL}
        elif [ $APT_VERSION = "new" ]; then
            genbasedir --flat --bloat --bz2only --progress \
               ${APTDIR}/${DISTR}/${VERSION} ${MODL}
        fi
    else
        echo -e "${RED_LIGHT}skipped ${OUT}(no release.${MODL} file)"
        return 1
    fi
}

#

#mk_rm() {
#    # elimina i pacchetti dal repository
#    if [ $1 = "rebuild" ]; then
#       rm -f ${APTDIR}/${DISTR}/${VERSION}/RPMS.updates/*
#    fi
#}

mk_rm() {
      # elimina i pacchetti dal repository
      rm -f ${APTDIR}/${DISTR}/${VERSION}/RPMS.$1/*
      rm -f ${APTDIR}/${DISTR}/${VERSION}/SRPMS.$1/*
}




#
mk_rep() {
    # updates binari
    CMD="$1"
    echo -ne "MIRRORDIR:  "
    if [ ! -z $MIRRORDIR ]; then
    echo -e "${GREEN}OK$OUT\nWorking..."
    find ${MIRRORDIR}/ -type f ! -name "*.src.rpm" \
        \( -name "*.rpm" -o -name "*.noarch.rpm" \) \
        -exec $CMD {} ${APTDIR}/${DISTR}/${VERSION}/RPMS.updates/ \
        2>/dev/null \;


    # updates sorgenti
    find ${MIRRORDIR}/ -type f -name "*.src.rpm" \
        -exec $CMD {} ${APTDIR}/${DISTR}/${VERSION}/SRPMS.updates/ \
        2>/dev/null \;
    else
    echo -e "${RED_LIGHT}SKIPPED!!${OUT}/n"
    fi



    # contrib binari
    echo -ne "CONTRIBDIR: "
    if [ ! -z $CONTRIBDIR ]; then
    echo -e "${GREEN}OK$OUT\nWorking..."
    find ${CONTRIBDIR}/ -type f ! -name "*.src.rpm" \
        \( -name "*.rpm" -o -name "*.noarch.rpm" \) \
        -exec $CMD {} ${APTDIR}/${DISTR}/${VERSION}/RPMS.contrib/ \
        2>/dev/null \;


    # contrib sorgenti
    find ${CONTRIBDIR}/ -type f -name "*.src.rpm" \
         -exec $CMD {} ${APTDIR}/${DISTR}/${VERSION}/SRPMS.contrib/ \
        2>/dev/null \;
    else
    echo -e "${RED_LIGHT}SKIPPED!!${OUT}"
    fi


}


hash80() {
    hash updates contrib
}    

# funzione per creare la struttura delle rirectory
mk_tree() {
   if [ -w $APTDIR ]; then
     BUILDTREE=$APTDIR/$DISTR/$VERSION
     echo -ne "Building dirtree $BUILDTREE\t\t"

     mkdir -p $BUILDTREE/base && \
     mkdir -p $BUILDTREE/RPMS.updates && \
     mkdir -p $BUILDTREE/SRPMS.updates && \
     mkdir -p $BUILDTREE/RPMS.contrib && \
     mkdir -p $BUILDTREE/SRPMS.contrib && \
     echo -e "${GREEN}OK$OUT" || echo -e "${RED}FAILED$OUT"
     echo -ne "Creating release files\t\t\t\t\t"
     echo -e "Archive: Stable\nComponent: updates\nOrigin: $DISTR\nLabel: $DISTR \
     \nVersion: $VERSION" > $BUILDTREE/base/release.updates &&
     echo -e "Archive: Stable\nComponent: contrib\nOrigin: $DISTR\nLabel: $DISTR \
     \nVersion: $VERSION" > $BUILDTREE/base/release.contrib &&
     # cp $BUILDTREE/release.* $BUILDTREE/base  &&
     echo -e "${GREEN}OK$OUT" || echo -e "${RED}FAILED$OUT"
     echo -e "$MSG_OUT"
      else
       echo -e "Spiacente, non hai i permessi di scrittura in $APTDIR"
   exit 1
   fi
}


# utilizzo del programma..
usage() {
     echo -e "${RED}USAGE:$OUT\nsusegen.sh --tree                # Build dirtree for APT repository\
     \nsusegen.sh --update              # Refresh APT repository\
     \nsusegen.sh --move                # Move files to repository\
     \nsusegen.sh --add                 # Add files to repository\
     \nsusegen.sh --copy                # Copy files to repository\
     \nsusegen.sh --rebuild  --action   # Delete e rebuild repository with action \
(--copy, --move, --add)\
     \nSee README for details !!!\n"
     exit 1
}


case $1 in


      --update)
      # updates repository
      echo -e "MODE: update\n"
      gen updates && \
      gen contrib && \
      hash80 && \
      echo -e "\n$MSG_OUT\n"
      ;;

      --add)
      # add rpm to repository
      echo -e "MODE: add\n"
      mk_rep ln off && \
      gen updates && \
      gen contrib && \
      hash80 && \
      echo -e "\n$MSG_OUT\n"
      ;;

      --tree)
      # tree
      mk_tree
      ;;

      --move)
      echo -e "MODE: move\n"
      mk_rep mv off && \
      gen updates && \
      gen contrib && \
      hash80 && \
      echo -e "\n$MSG_OUT\n"
      ;;

      --copy)
      echo -e "MODE: copy\n"
      mk_rep "cp -u" off && \
      gen updates && \
      gen contrib && \
      hash80 && \
      echo -e "\n$MSG_OUT\n"
      ;;

      --rebuild)
      if [ ! -z $2 ]; then
        if [ $2 = "--copy" ]; then
        echo -e "MODE: rebuild & copy\n" 
        mk_rm updates && \
        mk_rm contrib && \
        mk_rep "cp -u" && \
        gen updates && \
        gen contrib && \
        hash80 && \
        echo -e "\n$MSG_OUT\n"

        elif [ $2 = "--add" ]; then
        echo -e "MODE: rebuild & add\n" 
        mk_rm updates && \
        mk_rm contrib && \
        mk_rep ln && \
        gen updates && \
        gen contrib && \
        hash80 && \
        echo -e "\n$MSG_OUT\n"

        elif [ $2 = "--move" ]; then
        echo -e "MODE: rebuild & move\n"
        mk_rm updates && \
        mk_rm contrib && \
        mk_rep mv && \
        gen updates && \
        gen contrib && \
        hash80 && \
        echo -e "\n$MSG_OUT\n"

        else
        usage
        fi
      else
      usage
      fi
      ;;

      *)
      usage
      ;;
 esac
